import React, { Component } from 'react';
import Taro from '@tarojs/taro';
import { View, CoverImage, CoverView } from '@tarojs/components'
import './index.less'

import icon_home from './image/home.png';
import icon_liveb from './image/liveb.png';
import icon_user from './image/user.png';
import icon_selectUser from './image/selectUser.png';
import icon_selectLiveb from './image/selectLiveb.png';
import icon_selectHome from './image/selectHome.png';
import { connect } from "react-redux";
import { add, asyncAdd, minus } from "../actions/counter";

@connect(({ counter }) => ({
  counter
}), (dispatch) => ({
  add() {
    dispatch(add())
  },
  dec() {
    dispatch(minus())
  },
  asyncAdd() {
    dispatch(asyncAdd())
  }
}))
class CustomTabBar extends Component {
  constructor(props) {
    super(props);
    this.state = {
      color: "#9C9ABB",
      selectedColor: "#76D3FF",
      list: [
        {
          pagePath: "/pages/index/index",
          iconPath: icon_home,
          selectedIconPath: icon_selectHome,
          text: "首页"
        },
        {
          pagePath: "/pages/liveList/index",
          iconPath: icon_liveb,
          selectedIconPath: icon_selectLiveb,
          text: "直播"
        },
        {
          pagePath: "/pages/user/index",
          iconPath: icon_user,
          selectedIconPath: icon_selectUser,
          text: "我的"
        },
      ]
    }
    this.switchTab = this.switchTab.bind(this);
  }

  switchTab(value, key) {
    Taro.switchTab({
      url: value.pagePath
    })
  }

  render() {
    return (
      <View className='custom-tab-bar'>
        {/*<View  className='tab-bar-border'/>*/}
        {
          this.state.list.map((v, key) => (
            <View key={key} className='tab-bar-item' dataPath={v.pagePath} dataIndex={key} onClick={() => {
              this.switchTab(v, key);
            }}>
              <CoverImage className='coverImage' src={this.props.counter.num === key ? v.selectedIconPath : v.iconPath} />
              <View className='View' style={{ color: this.props.counter.num === key ? this.state.selectedColor : this.state.color }}>
                {v.text}
              </View>
              {/*{*/}
              {/*  key !== 1 ?*/}
              {/*    <>*/}
              {/*      <CoverImage className='coverImage' src={this.props.counter.num === key ? v.selectedIconPath : v.iconPath}/>*/}
              {/*      <View className='View'  style={{color:this.props.counter.num === key ? this.state.selectedColor : this.state.color}}>*/}
              {/*        {v.text}*/}
              {/*      </View>*/}
              {/*    </>:*/}
              {/*    <View className='center'>*/}
              {/*      <CoverImage className='centerCoverImage' src={this.props.counter.num === key ? v.selectedIconPath : v.iconPath}/>*/}
              {/*      <View className='View'  style={{color:this.props.counter.num === key ? this.state.selectedColor : this.state.color}}>{v.text}</View>*/}
              {/*    </View>*/}
              {/*}*/}
            </View >
          ))
        }
      </View >
    )
  }
}

export default CustomTabBar;
