/* eslint-disable import/prefer-default-export */
import HTTPREQUEST from "./http"
import Taro, {getCurrentPages} from "@tarojs/taro";

//登录
export const login = (res) => {
  return new Promise(async (resolve,_)=>{
    Taro.showLoading({
      title:'登录中...',
    })
    let userInfor = res.userInfo
    let loginMsg = await Taro.login();
    if (loginMsg.code) {
      try{
        let msg = await HTTPREQUEST.post('/wxLogin', {
          code:loginMsg.code,
          nickname:userInfor.nickName
        });
        if(msg.error.length === 0){
          userInfor.mobile = msg.data.mobile;
          Taro.setStorageSync('userInfor', userInfor);
          Taro.setStorageSync('token', msg.token);
          Taro.showToast({title:'登录成功',icon:'success'})
          resolve(userInfor.mobile);
        }else{
          Taro.showToast({title:msg.error[0].message,icon:'none'})
        }
      }catch (err) {
        Taro.showToast({title:'系统错误,请稍后重试',icon:'none'});
        console.log(err,'login')
      }
    } else {
      Taro.showToast({title:loginMsg.errMsg,icon:'none'})
      console.log('登录失败！' + loginMsg.errMsg)
    }
    Taro.hideLoading();
  })
}

//产品支付
export const pay = (postData) => {
  return HTTPREQUEST.post('/api/user/wxPush', postData)
}

//撤销支付
export const payClose = (postData) => {
  return HTTPREQUEST.get('/api/user/wxClose', postData)
}

//产品列表
export const getProjecList = (postData) => {
  return HTTPREQUEST.get('/open/projectList', postData)
}

//用户产品列表
export const getUserOrderList = (postData) => {
  return HTTPREQUEST.get('/api/user/order/list', postData)
}


//产品详情
export const getSelectProject = (postData) => {
  return HTTPREQUEST.get('/open/selectProject', postData)
}

//微信订单查询
export const wxQuery = (postData) => {
  return HTTPREQUEST.get('/api/user/wxQuery', postData)
}

//获取直播列表
export const getLiveList = (postData) => {
  return HTTPREQUEST.get('/api/user/getliveinfo', postData)
}

//上传手机号
export const setDecryptData = (postData) => {
  return HTTPREQUEST.post('/api/user/decryptData', postData)
}

//获取分享详情
export const getWeChatShareDetails = (postData) => {
  return HTTPREQUEST.get('/open/weChatDetails', postData)
}

//测试
export const test = (postData) => {
  return HTTPREQUEST.get('/open/test', postData)
}
